from optparse import OptionParser
from wtss.analysis.feature import Feature

fields = {1:"chrom", 2:"start", 3:"end", 4:"name"}

def divide(file, output_dir):
    chroms = {}
    
    ff = open(file, 'r')
    for line in ff.readlines():
        cols = line.split("\t")
        if not chroms.has_key(cols[1]):
            chroms[cols[1]] = [line]
        else:
            chroms[cols[1]].append(line)
    ff.close()

    print len(chroms.keys())

    for chrom,lines in chroms.iteritems():
        output_file = output_dir + "/" + chrom + "_phast.txt"
        print chrom, len(lines), output_file
        ff = open(output_file, "w")
        ff.writelines(lines)
        ff.close()

def parse(file):
    features = []
    ff = open(file, 'r')
    for line in ff.readlines():
        cols = line.split("\t")
        #features.append([cols[4], cols[1], cols[2], cols[3]])
        features.append(Feature(cols[4], cols[1], cols[2], cols[3]))
    ff.close()
    return features

if __name__ == '__main__':
    usage = "Usage: %prog"

    parser = OptionParser(usage=usage)
    parser.add_option("-d", "--divide", dest="divide", help="input(file) outdir", nargs=2)
    parser.add_option("-r", "--retrieve", dest="retrieve", help=".pkl file")

    (options, args) = parser.parse_args()

    if options.divide:
        divide(options.divide[0], options.divide[1])
    elif options.retrieve:
        features = parse(options.retrieve)
        print len(features), features[0].details()

